////////////////////////////////////////////////////////////
//  it's updated 2003.3
//  Resouce include

#include <windowsx.h>
#include <windows.h>
#include <commdlg.h>
#include <stdio.h>
#include <math.h>

#include "BmpView.h"
#include "MyBitmap.h"

////////////////////////////////////////////////////////////
//
//  Resouce include
#include "res/resource.h"


////////////////////////////////////////////////////////////
//
//  Global variables
HINSTANCE g_hInst;  // Main 
HWND g_hDlgInfoHeader; // InfoHeader Dialog
HWND g_hDlgPalette; // Palettes Dialog
HWND g_hDlgAbout; // About Dialog

char g_szFileName[MAX_FILE_NAME];  // bitmap file name

LPSTR lpszClass="BMPVIEW";  // Main windows class name

HBITMAP hNoEntryBitmap;
BITMAPFILEHEADER *pBitmapFileHeader=NULL;  // Bitmap file header pointer
BITMAPINFOHEADER *pBitmapInfoHeader;  // Bitmap file infomatio header pointer
RGBQUAD *pPaletteTable;  // Bitmap palettes data pointer
BYTE *pBitmapData;  // Bitmap data pointer

BOOL bOnLoad;
BOOL bOnSave;

////////////////////////////////////////////////////////////
//
//  Win32 Main Entrypoint
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;

	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(GRAY_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=MAKEINTRESOURCE(IDR_MENU1);
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass
		,WS_OVERLAPPEDWINDOW
		,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT
		,NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);

	while(GetMessage(&Message,0,0,0))
	{
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

////////////////////////////////////////////////////////////
//
//  Windows Callback Procdure
LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	switch(iMessage)
	{
		HANDLE_MSG(hWnd,WM_CREATE,BmpView_OnCreate);
		HANDLE_MSG(hWnd,WM_COMMAND,BmpView_OnCommand);
		HANDLE_MSG(hWnd,WM_DESTROY,BmpView_OnDestroy);
		HANDLE_MSG(hWnd,WM_PAINT,BmpView_OnPaint);
		HANDLE_MSG(hWnd,WM_INITMENU,BmpView_OnInitMenu);
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}

////////////////////////////////////////////////////////////
//
//  
BOOL BmpView_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
	HWND hWndTop;
	RECT rt;
	int width,height;

	width=500;
	height=500;

	// Load Bitmap...
	hNoEntryBitmap=LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_NOENTRYPALETTE));
	// Set Menu disable...
	bOnLoad=FALSE;
	bOnSave=FALSE;

	hWndTop=GetDesktopWindow();
	GetWindowRect(hWndTop,&rt);
	MoveWindow(hWnd,rt.right/2-width/2,rt.bottom/2-height/2,width,height,TRUE);
	return TRUE;
}

void BmpView_OnInitMenu(HWND hWnd, HMENU hMenu)   // (HMENU) wParam
{
	EnableMenuItem(hMenu,IDM_SAVE,bOnSave?MF_ENABLED:MF_GRAYED);
	EnableMenuItem(hMenu,IDM_SAVEAS,bOnSave?MF_ENABLED:MF_GRAYED);
	EnableMenuItem(hMenu,IDM_CLOSE,bOnLoad?MF_ENABLED:MF_GRAYED);

	EnableMenuItem(hMenu,IDM_SHOWINFOHEADER,bOnLoad?MF_ENABLED:MF_GRAYED);
	EnableMenuItem(hMenu,IDM_SHOWPALLETE,bOnLoad?MF_ENABLED:MF_GRAYED);

	EnableMenuItem(hMenu,IDM_CLOCKWISEROTATE,bOnLoad?MF_ENABLED:MF_GRAYED);
	EnableMenuItem(hMenu,IDM_ANTICLOCKWISEROTATE,bOnLoad?MF_ENABLED:MF_GRAYED);
	EnableMenuItem(hMenu,IDM_INVERTCOLOR,bOnLoad?MF_ENABLED:MF_GRAYED);
	EnableMenuItem(hMenu,IDM_MIRROR,bOnLoad?MF_ENABLED:MF_GRAYED);
}

void BmpView_OnDestroy(HWND hWnd)
{
	WinHelp(hWnd,"bmpview.hlp",HELP_QUIT,NULL);
	free(pBitmapFileHeader);
	DeleteObject(hNoEntryBitmap);
	PostQuitMessage(0);
}

void BmpView_OnPaint(HWND hWnd)
{
	HDC hdc;
	PAINTSTRUCT ps;

	hdc = BeginPaint(hWnd,&ps);

	if(pBitmapFileHeader)
		SetDIBitsToDevice(hdc,0,0,pBitmapInfoHeader->biWidth,pBitmapInfoHeader->biHeight,0,0,0,pBitmapInfoHeader->biHeight,pBitmapData,(BITMAPINFO*)pBitmapInfoHeader,DIB_RGB_COLORS);
	
	EndPaint(hWnd,&ps);
	
	FORWARD_WM_PAINT(hWnd,DefWindowProc);
}

void BmpView_OnCommand(HWND hWnd,int id,HWND hwndCtl,UINT codeNotify)
{
	switch(id)
	{
	case IDM_EXIT:
		PostQuitMessage(0);
		break;
	case IDM_OPEN:
		if(OpenBitmap(hWnd)==TRUE)
		{
			bOnLoad=TRUE;
			bOnSave=FALSE;
		}
		break;
	case IDM_SAVE:
		if(SaveBitmap(hWnd)==TRUE)
			bOnSave=FALSE;
		break;
	case IDM_SAVEAS:
		SaveAsBitmap(hWnd);
		bOnSave=FALSE;
		break;
	case IDM_CLOSE:
		if(Close(hWnd)==TRUE)
		{
			bOnLoad=FALSE;
			bOnSave=FALSE;
		}
		break;
	case IDM_SHOWINFOHEADER:
		// Modaless Dialog 
		if(!IsWindow(g_hDlgInfoHeader))
		{
			g_hDlgInfoHeader = CreateDialog(g_hInst,MAKEINTRESOURCE(IDD_BITMAPINFOHEADER),hWnd,(DLGPROC)ShowInfoHeaderDlgProc);
			ShowWindow(g_hDlgInfoHeader, SW_SHOW);
		}
		break;
	case IDM_SHOWPALLETE:
		// Modaless Dialog 
		if(!IsWindow(g_hDlgPalette))
		{
			g_hDlgPalette = CreateDialog(g_hInst,MAKEINTRESOURCE(IDD_PALETTE),hWnd,(DLGPROC)ShowPaletteDlgProc);
			ShowWindow(g_hDlgPalette, SW_SHOW);
		}
		break;
	case IDM_CLOCKWISEROTATE:
		ClockWiseRotate(hWnd);
		bOnSave=TRUE;
		break;
	case IDM_ANTICLOCKWISEROTATE:
		AntiClockWiseRotate(hWnd);
		bOnSave=TRUE;
		break;
	case IDM_INVERTCOLOR:
		InvertColor(hWnd);
		bOnSave=TRUE;
		break;
	case IDM_MIRROR:
		Mirror(hWnd);
		bOnSave=TRUE;
		break;
	case IDM_HELP:
		//MessageBox(hWnd,"Sorry help is not ready...","INFORMATION",MB_OK|MB_ICONINFORMATION);
		WinHelp(hWnd,"bmpview.hlp",HELP_CONTENTS,NULL); 
		break;
	case IDM_ABOUT:
		// Modaless Dialog
		if(!IsWindow(g_hDlgAbout))
		{
			g_hDlgAbout = CreateDialog(g_hInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,(DLGPROC)AboutDlgProc);
			ShowWindow(g_hDlgAbout, SW_SHOW);
		}
		break;
	}
}

void MoveCenter(HWND hWnd)
{
	RECT toprt;
	int topx,topy,topwidth,topheight;
	GetWindowRect(GetDesktopWindow(),&toprt);
	topwidth=pBitmapInfoHeader->biWidth+8;
	if(topwidth<200)
		topwidth=208;
	topheight=pBitmapInfoHeader->biHeight+46;
	topx=toprt.right/2-topwidth/2;
	topy=toprt.bottom/2-topheight/2;
	if(topy<0)
		topy=50;
	MoveWindow(hWnd,topx,topy,topwidth,topheight,TRUE);
}
////////////////////////////////////////////////////////////
//
//  user functions OnCommand
BOOL OpenBitmap(HWND hWnd)
{
	HANDLE hFile;
	DWORD dwFileSize,dwRead;
	OPENFILENAME ofn;       // common dialog box structure

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFile = g_szFileName;
	ofn.nMaxFile = sizeof(g_szFileName);
	ofn.lpstrFilter = "Bitmap file(*.bmp)\0*.bmp\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	// really?
	if(bOnSave==TRUE)
		if(MessageBox(hWnd,"The file did not saved, really load?","WARNING",MB_OKCANCEL)==IDCANCEL)
			return FALSE;

	// Display the Open dialog box. 
	if(GetOpenFileName(&ofn)==FALSE)
		return FALSE;

	// load file
	hFile=CreateFile(ofn.lpstrFile, GENERIC_READ, FILE_SHARE_READ, (LPSECURITY_ATTRIBUTES) NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,(HANDLE) NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		MessageBox(hWnd,"This file can not open","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		return FALSE;
	}

	dwFileSize=GetFileSize(hFile,NULL);
	if (dwFileSize == INVALID_FILE_SIZE || dwFileSize==0) 
	{
		MessageBox(hWnd,"This file size error","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		return FALSE;
	}
	
	// existing DIB free because of new pBitmapFileHeader...
	if(pBitmapFileHeader)
		free(pBitmapFileHeader);
	pBitmapFileHeader=(BITMAPFILEHEADER*)malloc(dwFileSize);

	if(!pBitmapFileHeader)
	{
		MessageBox(hWnd,"Memory is not enough","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		return FALSE;
	}

	ReadFile(hFile,pBitmapFileHeader,dwFileSize,&dwRead,NULL);
	if(dwFileSize!=dwRead)
	{
		MessageBox(hWnd,"File read error","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		free(pBitmapFileHeader);
		pBitmapFileHeader=NULL;
		return FALSE;
	}
	CloseHandle(hFile);

	// load success
	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;
	pPaletteTable=(RGBQUAD *)((PBYTE)pBitmapInfoHeader+sizeof(BITMAPINFOHEADER));


	// BM not bitmap file
	if(pBitmapFileHeader->bfType!=*(WORD*)"BM")
	{
		MessageBox(hWnd,"This file is not BMP file","WARNING",MB_OK|MB_ICONERROR);
		free(pBitmapFileHeader);
		return FALSE;
	}
	// not supported 1,8,24 bpp
	if(pBitmapInfoHeader->biBitCount!=1 && pBitmapInfoHeader->biBitCount!=8 && pBitmapInfoHeader->biBitCount!=24)
	{
		MessageBox(hWnd,"This file is not supported","WARNING",MB_OK|MB_ICONERROR);
		free(pBitmapFileHeader);
		pBitmapFileHeader=NULL;
		InvalidateRect(hWnd,NULL,TRUE);
		return FALSE;
	}

	// if dialogbox exit, listbox init & color redraw & info redraw...
	if(g_hDlgPalette)
		SendMessage(g_hDlgPalette,WM_INITDIALOG,0,0);
	if(g_hDlgPalette)
		InvalidateRect(g_hDlgPalette,NULL,TRUE);
	if(g_hDlgInfoHeader)
		InvalidateRect(g_hDlgInfoHeader,NULL,TRUE);

	char title[300];
	wsprintf(title,"BmpView - %s",g_szFileName);
	SetWindowText(hWnd,title);

	MoveCenter(hWnd);
	// draw load bitmap
	//InvalidateRect(hWnd,NULL,TRUE);
	return TRUE;

}

BOOL SaveBitmap(HWND hWnd)
{
	HANDLE hFile;
	DWORD dwFileSize,dwWrite;

	// save file
	hFile=CreateFile(g_szFileName, GENERIC_WRITE, 0, (LPSECURITY_ATTRIBUTES) NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL,(HANDLE) NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		MessageBox(hWnd,"This file can not save","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		return FALSE;
	}

	dwFileSize=pBitmapFileHeader->bfOffBits+pBitmapInfoHeader->biSizeImage;

	WriteFile(hFile,pBitmapFileHeader,dwFileSize,&dwWrite,NULL);
	if(dwFileSize!=dwWrite)
	{
		MessageBox(hWnd,"File write error","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		free(pBitmapFileHeader);
		pBitmapFileHeader=NULL;
		return FALSE;
	}
	CloseHandle(hFile);

	char title[300];
	wsprintf(title,"BmpView - %s",g_szFileName);
	SetWindowText(hWnd,title);
	return TRUE;
}

BOOL SaveAsBitmap(HWND hWnd)
{
	HANDLE hFile;
	DWORD dwFileSize,dwWrite;
	OPENFILENAME ofn;       // common dialog box structure

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFile = g_szFileName;
	ofn.nMaxFile = sizeof(g_szFileName);
	ofn.lpstrFilter = "Bitmap file(*.bmp)\0*.bmp\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_CREATEPROMPT;
	//ofn.Flags = OFN_SHOWHELP | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST;

	// Display the Save dialog box. 
	if(GetSaveFileName(&ofn)==FALSE)
		return FALSE;

	// save file
	hFile=CreateFile(ofn.lpstrFile, GENERIC_WRITE, 0, (LPSECURITY_ATTRIBUTES) NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL,(HANDLE) NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		MessageBox(hWnd,"This file can not save","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		return FALSE;
	}

	dwFileSize=pBitmapFileHeader->bfOffBits+pBitmapInfoHeader->biSizeImage;

	WriteFile(hFile,pBitmapFileHeader,dwFileSize,&dwWrite,NULL);
	if(dwFileSize!=dwWrite)
	{
		MessageBox(hWnd,"File write error","ERROR",MB_OK|MB_ICONERROR);
		CloseHandle(hFile);
		free(pBitmapFileHeader);
		pBitmapFileHeader=NULL;
		return FALSE;
	}
	CloseHandle(hFile);

	char title[300];
	wsprintf(title,"BmpView - %s",g_szFileName);
	SetWindowText(hWnd,title);
	return TRUE;
}

BOOL Close(HWND hWnd)
{
	//  ʾ  θ ٽ ȮѴ.
	if(bOnSave==TRUE)
		if(MessageBox(hWnd,"The file did not saved, really closed?","WARNING",MB_OKCANCEL)==IDCANCEL)
			return FALSE;

	// ̾α׹ڽ   close Ѵ.
	if(g_hDlgPalette)
		DestroyWindow(g_hDlgPalette);
	if(g_hDlgInfoHeader)
		DestroyWindow(g_hDlgInfoHeader);

	free(pBitmapFileHeader);
	pBitmapFileHeader=NULL;
	SetWindowText(hWnd,"BmpView");
	InvalidateRect(hWnd,NULL,TRUE);

	return TRUE;
}


void AntiClockWiseRotate(HWND hWnd)
{
	BITMAPFILEHEADER *pBitmapFileHeaderTemp;
	pBitmapFileHeaderTemp=pBitmapFileHeader;
	if((pBitmapFileHeader=HongRotate90L(pBitmapFileHeader))==NULL)
	{
		// ȸ  ߻..޸ Ȯе..· ư..
		pBitmapFileHeader=pBitmapFileHeaderTemp;
	}

	if(g_hDlgInfoHeader)
		InvalidateRect(g_hDlgInfoHeader,NULL,TRUE);

	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;
	pPaletteTable=(RGBQUAD *)((PBYTE)pBitmapInfoHeader+sizeof(BITMAPINFOHEADER));

	MoveCenter(hWnd);

}

void ClockWiseRotate(HWND hWnd)
{
	BITMAPFILEHEADER *pBitmapFileHeaderTemp;
	pBitmapFileHeaderTemp=pBitmapFileHeader;
	if((pBitmapFileHeader=HongRotate90R(pBitmapFileHeader))==NULL)
	{
		// ȸ  ߻..޸ Ȯе..· ư..
		pBitmapFileHeader=pBitmapFileHeaderTemp;
	}

	if(g_hDlgInfoHeader)
		InvalidateRect(g_hDlgInfoHeader,NULL,TRUE);

	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;
	pPaletteTable=(RGBQUAD *)((PBYTE)pBitmapInfoHeader+sizeof(BITMAPINFOHEADER));

	MoveCenter(hWnd);
}

void InvertColor(HWND hWnd)
{
	int width,height;

	width=pBitmapInfoHeader->biWidth;
	height=pBitmapInfoHeader->biHeight;
	
	HongInvertColor(pBitmapFileHeader,0,0,width,height);

	InvalidateRect(hWnd,NULL,TRUE);
}

void Mirror(HWND hWnd)
{
	int width,height;

	width=pBitmapInfoHeader->biWidth;
	height=pBitmapInfoHeader->biHeight;

	HongMirror(pBitmapFileHeader,0,0,width,height);

	InvalidateRect(hWnd,NULL,TRUE);
}



////////////////////////////////////////////////////////////
//
//  ShowInfoHeader Dialog Procedure
LRESULT CALLBACK ShowInfoHeaderDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	switch(iMessage)
	{
		HANDLE_MSG(hDlg,WM_INITDIALOG,DlgShowInfo_OnInitDialog);
		HANDLE_MSG(hDlg,WM_COMMAND,DlgShowInfo_OnCommand);
		HANDLE_MSG(hDlg,WM_PAINT,DlgShowInfo_OnPaint);
	}
	return FALSE;
}

BOOL DlgShowInfo_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam)
{

	return TRUE;
}

void DlgShowInfo_OnCommand(HWND hDlg,int id,HWND hwndCtl,UINT codeNotify)
{
	switch(id)
	{
	case IDOK:
	case IDCANCEL:
		 DestroyWindow(hDlg);
		break;
	}
}

void DlgShowInfo_OnPaint(HWND hDlg)
{
	SetDlgItemInt(g_hDlgInfoHeader,IDC_BITMAPSIZE,pBitmapInfoHeader->biSize,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_WIDTH,pBitmapInfoHeader->biWidth,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_HEIGHT,pBitmapInfoHeader->biHeight,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_PLANES,pBitmapInfoHeader->biPlanes,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_BITCOUNT,pBitmapInfoHeader->biBitCount,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_COMPRESSION,pBitmapInfoHeader->biCompression,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_SIZEIMAGE,pBitmapInfoHeader->biSizeImage,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_XPELSPERMETER,pBitmapInfoHeader->biXPelsPerMeter,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_YPELSPERMETER,pBitmapInfoHeader->biYPelsPerMeter,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_CLRUSED,pBitmapInfoHeader->biClrUsed,FALSE);
	SetDlgItemInt(g_hDlgInfoHeader,IDC_CLRIMPORTANT,pBitmapInfoHeader->biClrImportant,FALSE);

	FORWARD_WM_PAINT(hDlg,DefWindowProc);
}
//  ShowInfoHeader Dialog Procedure
//
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
//
//  ShowPalettes Dialog Procedure
LRESULT CALLBACK ShowPaletteDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	switch(iMessage)
	{
		HANDLE_MSG(hDlg,WM_INITDIALOG,DlgPalette_OnInitDialog);
		HANDLE_MSG(hDlg,WM_COMMAND,DlgPalette_OnCommand);
		HANDLE_MSG(hDlg,WM_PAINT,DlgPalette_OnPaint);
	}
	return FALSE;
}

BOOL DlgPalette_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam)
{
	unsigned int i,j,count;
	unsigned int red,green,blue;
	char szPaletteIndex[40];
	long Style;
	HWND hListBox;


	// ListBox Style set
	hListBox = GetDlgItem(hDlg,IDC_PALETTELIST);
	Style = GetWindowLong(hListBox,GWL_STYLE);
	SetWindowLong(hListBox,GWL_STYLE,Style|LBS_DISABLENOSCROLL|LBS_NOTIFY);

	// hListBox reset
	ListBox_ResetContent(hListBox);

	// Get color index count
	count=(pBitmapInfoHeader->biClrUsed==0)?(int)pow(2,pBitmapInfoHeader->biBitCount):pBitmapInfoHeader->biClrUsed;

	// if 24bpp, No enty palette
	if(pBitmapInfoHeader->biBitCount==24)
	{
		ListBox_AddString(hListBox,"No Entry Palette");
		count=0;
	}
	else
	{
		for(i=0;i<count;i++)
		{
			red  =(pPaletteTable+i)->rgbRed;
			green=(pPaletteTable+i)->rgbGreen;
			blue =(pPaletteTable+i)->rgbBlue;

			j=sprintf(szPaletteIndex,"Index%03d R:%3d G:%3d B:%3d",i,red,green,blue);
			ListBox_AddString(hListBox,szPaletteIndex);
			//::SendDlgItemMessage,SendMessage
		}
	}
	
	SendMessage(hListBox,LB_SETCURSEL,0,0);

	return TRUE;
}

void DlgPalette_OnCommand(HWND hDlg,int id,HWND hwndCtl,UINT codeNotify)
{
	RECT rt={15,15,65,65};
	switch(id)  // loword
	{
	case IDOK:
	case IDCANCEL:
		DestroyWindow(hDlg);
		break;
	}
	switch(codeNotify)  // hiword
	{
	case LBN_SELCHANGE:
		InvalidateRect(hDlg,&rt,TRUE);
	break;
	}
}

void DlgPalette_OnPaint(HWND hDlg)
{

	unsigned int red,green,blue,index;
	HBRUSH hMyBrush; //,hOldBrush;
	HDC hDC,hMemDC;
	PAINTSTRUCT ps;
	HBITMAP hOldBitmap;
	RECT rt={15,15,55,55};

	hDC=BeginPaint(hDlg,&ps);

	index=SendMessage(GetDlgItem(hDlg,IDC_PALETTELIST),LB_GETCURSEL,0,0);
	//index = ListBox_GetCurSel(hDlg);

	if(pBitmapInfoHeader->biBitCount==24)
	{
		hMemDC=CreateCompatibleDC(hDC);
		hOldBitmap= (HBITMAP) SelectObject(hMemDC,hNoEntryBitmap);
		BitBlt(hDC,15,15,40,40,hMemDC,0,0,SRCCOPY);
		SelectObject(hMemDC,hOldBitmap);
		DeleteDC(hMemDC);
		//SendDlgItemMessage(hDlg,IDC_PALETTECOLOR,STM_SETIMAGE,IMAGE_BITMAP,(LPARAM)hNoEntryBitmap);
	}
	else
	{
		red  =(pPaletteTable+index)->rgbRed;
		green=(pPaletteTable+index)->rgbGreen;
		blue =(pPaletteTable+index)->rgbBlue;

		hMyBrush=CreateSolidBrush(RGB(red,green,blue));
		//hOldBrush=(HBRUSH)SelectObject(hDC,hMyBrush);

		FillRect(hDC,&rt,hMyBrush);
		//Rectangle(hDC,15,15,55,55);

		//SelectObject(hDC,hOldBrush);
		DeleteObject(hMyBrush);
	}

	EndPaint(hDlg,&ps);

	FORWARD_WM_PAINT(hDlg,DefWindowProc);

}
//  ShowPalettes Dialog Procedure
//
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
//
//  About Dialog Procedure
LRESULT CALLBACK AboutDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	switch(iMessage)
	{
		HANDLE_MSG(hDlg,WM_INITDIALOG,DlgAbout_OnInitDialog);
		HANDLE_MSG(hDlg,WM_COMMAND,DlgAbout_OnCommand);
		HANDLE_MSG(hDlg,WM_PAINT,DlgAbout_OnPaint);
	}
	return FALSE;
}

BOOL DlgAbout_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam)
{
	return TRUE;
}

void DlgAbout_OnCommand(HWND hDlg,int id,HWND hwndCtl,UINT codeNotify)
{
	switch(id)
	{
	case IDOK:
		DestroyWindow(hDlg);
		break;
	}
}

void DlgAbout_OnPaint(HWND hDlg)
{

	FORWARD_WM_PAINT(hDlg,DefWindowProc);
}
//  About Dialog Procedure
//
////////////////////////////////////////////////////////////





















